// DirectStreamWavDlg.h : header file
//

#if !defined(AFX_DIRECTSTREAMWAVDLG_H__4FE53A0B_06DD_4A23_B8F6_D4C69E83EA81__INCLUDED_)
#define AFX_DIRECTSTREAMWAVDLG_H__4FE53A0B_06DD_4A23_B8F6_D4C69E83EA81__INCLUDED_

#pragma warning(disable: 4786)

#import "..\..\..\common\VCProX.ocx"

using namespace VCProX;

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CDirectStreamWavDlg dialog

class CDirectStreamWavDlg : public CDialog
{
// Construction
public:
	CDirectStreamWavDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CDirectStreamWavDlg)
	enum { IDD = IDD_DIRECTSTREAMWAV_DIALOG };
	CComboBox	m_Codec;
	CComboBox	m_SamplingRate;
	CComboBox	m_ClientSocketType;
	CComboBox	m_ServerSocketType;
	CButton	m_ClientStop;
	CButton	m_ClientStart;
	CButton	m_ServerStop;
	CButton	m_ServerStart;
	CString	m_ServerPort;
	CString	m_ClientPort;
	CString	m_Host;
	CString	m_RecordFile;
	CString	m_PlaybackFile;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDirectStreamWavDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CDirectStreamWavDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnClose();
	afx_msg void OnButton1();
	afx_msg void OnButton2();
	afx_msg void OnButton3();
	afx_msg void OnButton4();
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	UINT_PTR timer;
	HexComPtr<HEX_IIID(IvcproWaveRiffX)> m_WaveRiffRead, m_WaveRiffWrite;
	HexComPtr<HEX_IIID(IvcproWaveResamplerX)> m_Resampler;
	HexComPtr<HEX_IIID(IvcproWaveCodecDeviceX)> m_Codec1, m_Codec2;
	HexComPtr<HEX_IIID(IvcproIpServerX)> m_IpServer;
	HexComPtr<HEX_IIID(IvcproIpClientX)> m_IpClient;

	DWORD m_dwCookie;

	void VCInit();
	void VCUninit();
	void SetLink(IvcproProviderPtr provider, IvcproConsumerPtr consumer);
	void ServerInit(bool bStart = true);
	void ClientInit(bool bStart = true);
	int SamplingRate(CComboBox& combo);
	int FormatTag(CComboBox& combo);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DIRECTSTREAMWAVDLG_H__4FE53A0B_06DD_4A23_B8F6_D4C69E83EA81__INCLUDED_)
